package MuGeN::FeatureDataSourceWindow::MicadoWindow;

use strict;

use MuGeN::FeatureDataSource::MicadoFeatureDataSource;

@MuGeN::FeatureDataSourceWindow::MicadoWindow::ISA=qw(Gtk2::Dialog);

sub new {
    my $class=shift;
    my $manager=shift;

    my $self=new Gtk2::Dialog;
    $self->set_title('Micado Retrieval Window');
    $self->{manager}=$manager;


    if (MuGeN::FeatureDataSource::MicadoFeatureDataSource::init) {
	my $genomecombo=new Gtk2::Combo();
	my @genometab=MuGeN::FeatureDataSource::MicadoFeatureDataSource::get_complete_genome_names();
	$genomecombo->set_popdown_strings(@genometab);
	$genomecombo->entry->set_editable(0);
	$genomecombo->entry->signal_connect('changed',sub {$self->refresh_entry()});
	$genomecombo->show();
	$self->{genomecombo}=$genomecombo;
	$self->vbox->pack_start($genomecombo,1,1,1);
	
	my $accesshbox=new Gtk2::HBox(0);
	$accesshbox->show();
	$self->vbox->pack_start($accesshbox,1,1,1);
	my $accesslabel=new Gtk2::Label('Access Number');
	$accesslabel->show();
	$accesshbox->pack_start($accesslabel,1,1,1);
	my $accessentry=new Gtk2::Entry;
	$accessentry->show();
	$self->{accessentry}=$accessentry;
	$accesshbox->pack_start($accessentry,1,1,1);
	
	
	my $okbtn=new Gtk2::Button('OK');
	$okbtn->show();
	$okbtn->signal_connect('clicked',sub { $self->ok_clicked()});
	$self->action_area->pack_start($okbtn,1,1,1);
	my $cancelbtn=new Gtk2::Button('Cancel');
	$cancelbtn->show();
	$cancelbtn->signal_connect('clicked',sub {$self->hide(); return 1});
	$self->action_area->pack_start($cancelbtn,1,1,1);

    } else {
	my $errorlabel=new Gtk2::Label("Micado connection unavailable.");
	$errorlabel->show();
	$self->vbox->pack_start($errorlabel,1,1,1);
	my $proceedbtn=new Gtk2::Button('Proceed');
	$proceedbtn->show();
	$proceedbtn->signal_connect('clicked',sub {$self->hide(); return 1});
	$self->action_area->pack_start($proceedbtn,1,1,1);
    }

    bless $self,$class;

    return $self;
}


sub refresh_entry {
    my $self=shift;

    my $organism=$self->{genomecombo}->entry->get_text;
    my $accessnumber=MuGeN::FeatureDataSource::MicadoFeatureDataSource::get_access_number($organism);

    $self->{accessentry}->set_text($accessnumber);

    return 1;
}

sub ok_clicked {
    my $self=shift;

    $self->hide();
    my $cursor=new Gtk2::Gdk::Cursor('watch');
    while (Gtk2::events_pending($self)) {
	Gtk2::main_iteration($self);
      }

     my %args=(qualifiers=>1);

    my $accessnumber=$self->{accessentry}->get_text();
    if ($accessnumber =~ /\w{2}\d+/) {
	$args{accessnumber}=$accessnumber;
    } else {
	my $organism=$self->{genomecombo}->entry->get_text();
	$args{organism}=$organism;
    }

    my $datasource=new MuGeN::FeatureDataSource::MicadoFeatureDataSource(%args);

    $self->{manager}->_add_map_from_datasource($datasource);

    return 1;
}

1
